diff --git a/src/backend/optimizer/path/joinpath.c b/src/backend/optimizer/path/joinpath.c
index 02a6302..aa3362b 100644
--- a/src/backend/optimizer/path/joinpath.c
+++ b/src/backend/optimizer/path/joinpath.c
@@ -1850,32 +2737,96 @@ hash_inner_and_outer(PlannerInfo *root,
 			Path	   *cheapest_partial_outer;
 			Path	   *cheapest_safe_inner = NULL;
 
-			cheapest_partial_outer =
-				(Path *) linitial(outerrel->partial_pathlist);
+			if (grouped_outer)
+			{
+				if (REL_HAS_PARTIAL_GROUPED_PATHS(outerrel))
+				{
+					cheapest_partial_outer =
+						(Path *) linitial(outerrel->gpi->partial_pathlist);
+				}
+				else
+					return;
+			}
+			else
+				cheapest_partial_outer =
+					(Path *) linitial(outerrel->partial_pathlist);
 
 			/*
 			 * Normally, given that the joinrel is parallel-safe, the cheapest
 			 * total inner path will also be parallel-safe, but if not, we'll
-			 * have to search for the cheapest safe, unparameterized inner
-			 * path.  If doing JOIN_UNIQUE_INNER, we can't use any alternative
-			 * inner path.
+			 * have to search cheapest_parameterized_paths for the cheapest
+			 * safe, unparameterized inner path.  If doing JOIN_UNIQUE_INNER,
+			 * we can't use any alternative inner path.
 			 */
 			if (cheapest_total_inner->parallel_safe)
 				cheapest_safe_inner = cheapest_total_inner;
 			else if (save_jointype != JOIN_UNIQUE_INNER)
-				cheapest_safe_inner =
-					get_cheapest_parallel_safe_total_inner(innerrel->pathlist);
+			{
+				ListCell   *lc;
+				List	   *inner_pathlist;
+
+				inner_pathlist = !grouped_inner ?
+					innerrel->cheapest_parameterized_paths :
+					innerrel->gpi->pathlist;
+
+				foreach(lc, inner_pathlist)
+				{
+					Path	   *innerpath = (Path *) lfirst(lc);
+
+					if (innerpath->parallel_safe &&
+						bms_is_empty(PATH_REQ_OUTER(innerpath)))
+					{
+						cheapest_safe_inner = innerpath;
+						break;
+					}
+				}
+			}
 
 			if (cheapest_safe_inner != NULL)
-				try_partial_hashjoin_path(root, joinrel,
-										  cheapest_partial_outer,
-										  cheapest_safe_inner,
-										  hashclauses, jointype, extra);
+				try_hashjoin_path_common(root, joinrel,
+										 cheapest_partial_outer,
+										 cheapest_safe_inner,
+										 hashclauses, jointype, extra,
+										 true,
+										 grouped_outer, grouped_inner,
+										 do_aggregate);
 		}
 	}
 }
 
 /*
+ * hash_inner_and_outer
+ *	  Create hashjoin join paths by explicitly hashing both the outer and
+ *	  inner keys of each available hash clause.
+ *
+ * 'joinrel' is the join relation
+ * 'outerrel' is the outer join relation
+ * 'innerrel' is the inner join relation
+ * 'jointype' is the type of join to do
+ * 'extra' contains additional input values
+ */
+static void
+hash_inner_and_outer(PlannerInfo *root,
+					 RelOptInfo *joinrel,
+					 RelOptInfo *outerrel,
+					 RelOptInfo *innerrel,
+					 JoinType jointype,
+					 JoinPathExtraData *extra)
+{
+	/* Plain (non-grouped) join. */
+	hash_inner_and_outer_common(root, joinrel, outerrel, innerrel,
+								jointype, extra, false, false, false);
+
+	/* Use all the supported strategies to generate grouped join. */
+	hash_inner_and_outer_common(root, joinrel, outerrel, innerrel,
+								jointype, extra, true, false, false);
+	hash_inner_and_outer_common(root, joinrel, outerrel, innerrel,
+								jointype, extra, false, true, false);
+	hash_inner_and_outer_common(root, joinrel, outerrel, innerrel,
+								jointype, extra, false, false, true);
+}
+
+/*
  * select_mergejoin_clauses
  *	  Select mergejoin clauses that are usable for a particular join.
  *	  Returns a list of RestrictInfo nodes for those clauses.
diff --git a/src/backend/optimizer/path/joinrels.c b/src/backend/optimizer/path/joinrels.c
index 453f259..cdd6d18 100644
--- a/src/backend/optimizer/path/joinrels.c
+++ b/src/backend/optimizer/path/joinrels.c
@@ -1232,7 +1232,7 @@ mark_dummy_rel(RelOptInfo *rel)
 	rel->partial_pathlist = NIL;
 
 	/* Set up the dummy path */
-	add_path(rel, (Path *) create_append_path(rel, NIL, NULL, 0, NIL));
+	add_path(rel, (Path *) create_append_path(rel, NIL, NULL, 0, NIL), false);
 
 	/* Set or update cheapest_total_path and related fields */
 	set_cheapest(rel);
@@ -1403,7 +1403,6 @@ try_partition_wise_join(PlannerInfo *root, RelOptInfo *rel1, RelOptInfo *rel2,
 			(List *) adjust_appendrel_attrs(root,
 											(Node *) parent_restrictlist,
 											nappinfos, appinfos);
-		pfree(appinfos);
 
 		child_joinrel = joinrel->part_rels[cnt_parts];
 		if (!child_joinrel)
@@ -1413,7 +1412,15 @@ try_partition_wise_join(PlannerInfo *root, RelOptInfo *rel1, RelOptInfo *rel2,
 												 child_sjinfo,
 												 child_sjinfo->jointype);
 			joinrel->part_rels[cnt_parts] = child_joinrel;
+
+			/*
+			 * If the parent join can be grouped, so can be its children.
+			 */
+			if (joinrel->gpi != NULL)
+				build_chiid_rel_gpi(root, child_joinrel, joinrel, nappinfos,
+									appinfos);
 		}
+		pfree(appinfos);
 
 		Assert(bms_equal(child_joinrel->relids, child_joinrelids));
 
diff --git a/src/backend/optimizer/path/pathkeys.c b/src/backend/optimizer/path/pathkeys.c
index c6870d3..c267d48 100644
--- a/src/backend/optimizer/path/pathkeys.c
+++ b/src/backend/optimizer/path/pathkeys.c
@@ -1563,3 +1563,157 @@ has_useful_pathkeys(PlannerInfo *root, RelOptInfo *rel)
 		return true;			/* might be able to use them for ordering */
 	return false;				/* definitely useless */
 }
+
+/*
+ * Add a new set of unique keys to path's list of unique key sets. If an
+ * identical set is already there --- free new_set instead of adding it.
+ */
+void
+add_uniquekeys_to_path(Path *path, Bitmapset *new_set)
+{
+	ListCell   *lc;
+
+	foreach(lc, path->uniquekeys)
+	{
+		Bitmapset  *set = (Bitmapset *) lfirst(lc);
+
+		if (bms_equal(new_set, set))
+			break;
+	}
+	if (lc == NULL)
+		path->uniquekeys = lappend(path->uniquekeys, new_set);
+	else
+		bms_free(new_set);
+}
+
+/*
+ * Return true if path output is grouped in a way described by
+ * root->group_pathkeys. AGGSPLIT_FINAL_DESERIAL can be skipped in such a
+ * case.
+ */
+bool
+match_path_to_group_pathkeys(PlannerInfo *root, Path *path)
+{
+	Bitmapset  *uniquekeys_all = NULL;
+	ListCell   *l1;
+	int			i;
+	bool	   *is_group_expr;
+
+	/*
+	 * group_pathkeys are essential for this function.
+	 */
+	if (root->group_pathkeys == NIL)
+		return false;
+
+	/*
+	 * The path is not aware of being unique.
+	 */
+	if (path->uniquekeys == NIL)
+		return false;
+
+	/*
+	 * There can be multiple known unique key sets. Gather pathkeys of all the
+	 * unique expressions the sets may reference.
+	 */
+	foreach(l1, path->uniquekeys)
+	{
+		Bitmapset  *set = (Bitmapset *) lfirst(l1);
+
+		uniquekeys_all = bms_union(uniquekeys_all, set);
+	}
+
+	/*
+	 * Find pathkeys for the expressions.
+	 */
+	is_group_expr = (bool *)
+		palloc0(list_length(path->pathtarget->exprs) * sizeof(bool));
+
+	i = 0;
+	foreach(l1, path->pathtarget->exprs)
+	{
+		Expr	   *expr = (Expr *) lfirst(l1);
+
+		if (bms_is_member(i, uniquekeys_all))
+		{
+			ListCell   *l2;
+			bool		found = false;
+
+			/*
+			 * This is an unique expression, so find its pathkey.
+			 */
+			foreach(l2, root->group_pathkeys)
+			{
+				PathKey    *pk = lfirst_node(PathKey, l2);
+				EquivalenceClass *ec = pk->pk_eclass;
+				ListCell   *l3;
+				EquivalenceMember *em = NULL;
+
+				if (ec->ec_below_outer_join)
+					continue;
+				if (ec->ec_has_volatile)
+					continue;
+
+				foreach(l3, ec->ec_members)
+				{
+					em = lfirst_node(EquivalenceMember, l3);
+
+					if (em->em_nullable_relids)
+						continue;
+
+					if (equal(em->em_expr, expr))
+					{
+						found = true;
+						break;
+					}
+				}
+				if (found)
+					break;
+
+			}
+			is_group_expr[i] = found;
+		}
+
+		i++;
+	}
+
+	/*
+	 * Now check the unique key sets and see if any one matches all items of
+	 * group_pathkeys.
+	 */
+	foreach(l1, path->uniquekeys)
+	{
+		Bitmapset  *set = (Bitmapset *) lfirst(l1);
+		bool		found = false;
+
+		/*
+		 * Collect PKs associated with this set.
+		 */
+		for (i = 0; i < list_length(path->pathtarget->exprs); i++)
+		{
+			if (bms_is_member(i, set))
+			{
+				/*
+				 * If the set misses a single grouping path key, at least one
+				 * expression of the unique key is outside the grouping
+				 * expressions, and thus the grouping expressions are not
+				 * guaranteed to be unique. Thus the avoidance of final
+				 * aggregation is not justified.
+				 */
+				if (!is_group_expr[i])
+				{
+					found = true;
+					break;
+				}
+			}
+		}
+
+		/*
+		 * No problem with this set. No need to check the other ones.
+		 */
+		if (!found)
+			return true;
+	}
+
+	/* No match found. */
+	return false;
+}
diff --git a/src/backend/optimizer/path/tidpath.c b/src/backend/optimizer/path/tidpath.c
index a2fe661..91d855c 100644
--- a/src/backend/optimizer/path/tidpath.c
+++ b/src/backend/optimizer/path/tidpath.c
@@ -266,5 +266,5 @@ create_tidscan_paths(PlannerInfo *root, RelOptInfo *rel)
 
 	if (tidquals)
 		add_path(rel, (Path *) create_tidscan_path(root, rel, tidquals,
-												   required_outer));
+												   required_outer), false);
 }
diff --git a/src/backend/optimizer/plan/createplan.c b/src/backend/optimizer/plan/createplan.c
index d445477..f123fbb 100644
--- a/src/backend/optimizer/plan/createplan.c
+++ b/src/backend/optimizer/plan/createplan.c
@@ -250,6 +250,7 @@ static Plan *prepare_sort_from_pathkeys(Plan *lefttree, List *pathkeys,
 static EquivalenceMember *find_ec_member_for_tle(EquivalenceClass *ec,
 					   TargetEntry *tle,
 					   Relids relids);
+static TargetEntry *get_aggref_from_tle(TargetEntry *tle);
 static Sort *make_sort_from_pathkeys(Plan *lefttree, List *pathkeys,
 						Relids relids);
 static Sort *make_sort_from_groupcols(List *groupcls,
@@ -808,6 +809,12 @@ use_physical_tlist(PlannerInfo *root, Path *path, int flags)
 		return false;
 
 	/*
+	 * Grouped relation's target list contains GroupedVars.
+	 */
+	if (rel->gpi != NULL)
+		return false;
+
+	/*
 	 * If a bitmap scan's tlist is empty, keep it as-is.  This may allow the
 	 * executor to skip heap page fetches, and in any case, the benefit of
 	 * using a physical tlist instead would be minimal.
@@ -1585,8 +1592,9 @@ create_projection_plan(PlannerInfo *root, ProjectionPath *best_path)
 	 * creation, but that would add expense to creating Paths we might end up
 	 * not using.)
 	 */
-	if (is_projection_capable_path(best_path->subpath) ||
-		tlist_same_exprs(tlist, subplan->targetlist))
+	if (!best_path->force_result &&
+		(is_projection_capable_path(best_path->subpath) ||
+		 tlist_same_exprs(tlist, subplan->targetlist)))
 	{
 		/* Don't need a separate Result, just assign tlist to subplan */
 		plan = subplan;
@@ -5633,6 +5641,9 @@ prepare_sort_from_pathkeys(Plan *lefttree, List *pathkeys,
 			tle = get_tle_by_resno(tlist, reqColIdx[numsortkeys]);
 			if (tle)
 			{
+				/* Handle special cases of sorting by aggregate. */
+				tle = get_aggref_from_tle(tle);
+
 				em = find_ec_member_for_tle(ec, tle, relids);
 				if (em)
 				{
@@ -5664,6 +5675,10 @@ prepare_sort_from_pathkeys(Plan *lefttree, List *pathkeys,
 			foreach(j, tlist)
 			{
 				tle = (TargetEntry *) lfirst(j);
+
+				/* Handle special cases of sorting by aggregate. */
+				tle = get_aggref_from_tle(tle);
+
 				em = find_ec_member_for_tle(ec, tle, relids);
 				if (em)
 				{
@@ -5837,6 +5852,49 @@ find_ec_member_for_tle(EquivalenceClass *ec,
 }
 
 /*
+ * Get Aggref from target entry if it's wrapped in GroupedVar.
+ */
+static TargetEntry *
+get_aggref_from_tle(TargetEntry *tle)
+{
+	/*
+	 * Does this happen to be an aggregate final function referencing the
+	 * partial aggregate? This can replace the final aggregation if the path
+	 * generates an unique set of grouping keys.
+	 */
+	if (IS_AGGFINALFN_STANDALONE(tle->expr))
+	{
+		FuncExpr   *fexpr = castNode(FuncExpr, tle->expr);
+		GroupedVar *gvar = linitial_node(GroupedVar, fexpr->args);
+		Aggref	   *aggref = castNode(Aggref, gvar->gvexpr);
+
+		Assert(fexpr->funcid == aggref->aggfinalfn);
+
+		tle = flatCopyTargetEntry(tle);
+		tle->expr = (Expr *) aggref;
+	}
+
+	/*
+	 * Aggregate w/o aggfinalfn?
+	 */
+	else if (IsA(tle->expr, GroupedVar))
+	{
+		GroupedVar *gvar = castNode(GroupedVar, tle->expr);
+
+		if (IsA(gvar->gvexpr, Aggref))
+		{
+			Aggref	   *aggref = castNode(Aggref, gvar->gvexpr);
+
+			Assert(aggref->aggfinalfn == InvalidOid);
+			tle = flatCopyTargetEntry(tle);
+			tle->expr = (Expr *) aggref;
+		}
+	}
+
+	return tle;
+}
+
+/*
  * make_sort_from_pathkeys
  *	  Create sort plan to sort according to given pathkeys
  *
diff --git a/src/backend/optimizer/plan/initsplan.c b/src/backend/optimizer/plan/initsplan.c
index 448cb73..102791b 100644
--- a/src/backend/optimizer/plan/initsplan.c
+++ b/src/backend/optimizer/plan/initsplan.c
@@ -14,8 +14,10 @@
  */
 #include "postgres.h"
 
+#include "access/sysattr.h"
 #include "catalog/pg_type.h"
 #include "catalog/pg_class.h"
+#include "catalog/pg_constraint_fn.h"
 #include "nodes/nodeFuncs.h"
 #include "optimizer/clauses.h"
 #include "optimizer/cost.h"
@@ -27,6 +29,7 @@
 #include "optimizer/planner.h"
 #include "optimizer/prep.h"
 #include "optimizer/restrictinfo.h"
+#include "optimizer/tlist.h"
 #include "optimizer/var.h"
 #include "parser/analyze.h"
 #include "rewrite/rewriteManip.h"
@@ -46,6 +49,8 @@ typedef struct PostponedQual
 } PostponedQual;
 
 
+static void create_aggregate_grouped_var_infos(PlannerInfo *root);
+static void create_grouping_expr_grouped_var_infos(PlannerInfo *root);
 static void extract_lateral_references(PlannerInfo *root, RelOptInfo *brel,
 						   Index rtindex);
 static List *deconstruct_recurse(PlannerInfo *root, Node *jtnode,
@@ -241,6 +246,558 @@ add_vars_to_targetlist(PlannerInfo *root, List *vars,
 	}
 }
 
+/*
+ * Add GroupedVarInfo to grouped_var_list for each aggregate as well as for
+ * each possible grouping expression and setup GroupedPathInfo for each base
+ * relation that can product grouped paths.
+ *
+ * root->group_pathkeys must be setup before this function is called.
+ */
+extern void
+add_grouping_info_to_base_rels(PlannerInfo *root)
+{
+	int			i;
+	ListCell   *lc;
+
+	/*
+	 * Isn't user interested in the aggregate push-down feature?
+	 */
+	if (!enable_agg_pushdown)
+		return;
+
+	/* No grouping in the query? */
+	if (!root->parse->groupClause)
+		return;
+
+	/*
+	 * Grouping sets require multiple different groupings but the base
+	 * relation can only generate one.
+	 */
+	if (root->parse->groupingSets)
+		return;
+
+	/*
+	 * TODO Consider if this is a real limitation.
+	 */
+	if (root->parse->hasWindowFuncs)
+		return;
+
+	/* Create GroupedVarInfo per (distinct) aggregate. */
+	create_aggregate_grouped_var_infos(root);
+
+	/* Is no grouping is possible below the top-level join? */
+	if (root->grouped_var_list == NIL)
+		return;
+
+	/* Create GroupedVarInfo per grouping expression. */
+	create_grouping_expr_grouped_var_infos(root);
+
+	/* Process the individual base relations. */
+	for (i = 1; i < root->simple_rel_array_size; i++)
+	{
+		RelOptInfo *rel = root->simple_rel_array[i];
+
+		/*
+		 * "other rels" will have their targets built later, by translation of
+		 * the target of the parent rel - see set_append_rel_size. If we
+		 * wanted to prepare the child rels here, we'd need another iteration
+		 * of simple_rel_array_size.
+		 */
+		if (rel != NULL && rel->reloptkind == RELOPT_BASEREL)
+			prepare_rel_for_grouping(root, rel);
+	}
+
+	/*
+	 * Now that we know that grouping can be pushed down, search for the
+	 * maximum sortgroupref. The base relations may need it if extra grouping
+	 * expressions get added to them.
+	 */
+	Assert(root->max_sortgroupref == 0);
+	foreach(lc, root->processed_tlist)
+	{
+		TargetEntry *te = lfirst_node(TargetEntry, lc);
+
+		if (te->ressortgroupref > root->max_sortgroupref)
+			root->max_sortgroupref = te->ressortgroupref;
+	}
+}
+
+/*
+ * Create GroupedVarInfo for each distinct aggregate.
+ *
+ * If any aggregate is not suitable, set root->grouped_var_list to NIL and
+ * return.
+ */
+static void
+create_aggregate_grouped_var_infos(PlannerInfo *root)
+{
+	List	   *tlist_exprs;
+	ListCell   *lc;
+
+	Assert(root->grouped_var_list == NIL);
+
+	tlist_exprs = pull_var_clause((Node *) root->processed_tlist,
+								  PVC_INCLUDE_AGGREGATES);
+
+	/*
+	 * Although GroupingFunc is related to root->parse->groupingSets, this
+	 * field does not necessarily reflect its presence.
+	 */
+	foreach(lc, tlist_exprs)
+	{
+		Expr	   *expr = (Expr *) lfirst(lc);
+
+		if (IsA(expr, GroupingFunc))
+			return;
+	}
+
+	/*
+	 * Aggregates within the HAVING clause need to be processed in the same
+	 * way as those in the main targetlist.
+	 */
+	if (root->parse->havingQual != NULL)
+	{
+		List	   *having_exprs;
+
+		having_exprs = pull_var_clause((Node *) root->parse->havingQual,
+									   PVC_INCLUDE_AGGREGATES);
+		if (having_exprs != NIL)
+			tlist_exprs = list_concat(tlist_exprs, having_exprs);
+	}
+
+	if (tlist_exprs == NIL)
+		return;
+
+	/* tlist_exprs may also contain Vars, but we only need Aggrefs. */
+	foreach(lc, tlist_exprs)
+	{
+		Expr	   *expr = (Expr *) lfirst(lc);
+		Aggref	   *aggref;
+		ListCell   *lc2;
+		GroupedVarInfo *gvi;
+		bool		exists;
+
+		if (IsA(expr, Var))
+			continue;
+
+		aggref = castNode(Aggref, expr);
+
+		/* TODO Think if (some of) these can be handled. */
+		if (aggref->aggvariadic ||
+			aggref->aggdirectargs || aggref->aggorder ||
+			aggref->aggdistinct || aggref->aggfilter)
+		{
+			/*
+			 * Partial aggregation is not useful if at least one aggregate
+			 * cannot be evaluated below the top-level join.
+			 *
+			 * XXX Is it worth freeing the GroupedVarInfos and their subtrees?
+			 */
+			root->grouped_var_list = NIL;
+			break;
+		}
+
+		/*
+		 * Aggregation push-down does not work w/o aggcombinefn. This field is
+		 * not mandatory, so check if this particular aggregate can handle
+		 * partial aggregation.
+		 */
+		if (!OidIsValid(aggref->aggcombinefn))
+		{
+			root->grouped_var_list = NIL;
+			break;
+		}
+
+		/* Does GroupedVarInfo for this aggregate already exist? */
+		exists = false;
+		foreach(lc2, root->grouped_var_list)
+		{
+			gvi = lfirst_node(GroupedVarInfo, lc2);
+
+			if (equal(expr, gvi->gvexpr))
+			{
+				exists = true;
+				break;
+			}
+		}
+
+		/* Construct a new GroupedVarInfo if does not exist yet. */
+		if (!exists)
+		{
+			Relids		relids;
+
+			/* TODO Initialize gv_width. */
+			gvi = makeNode(GroupedVarInfo);
+
+			gvi->gvid = list_length(root->grouped_var_list);
+			gvi->gvexpr = (Expr *) copyObject(aggref);
+			gvi->agg_partial = copyObject(aggref);
+			mark_partial_aggref(gvi->agg_partial, AGGSPLIT_INITIAL_SERIAL);
+
+			/* Find out where the aggregate should be evaluated. */
+			relids = pull_varnos((Node *) aggref);
+			if (!bms_is_empty(relids))
+				gvi->gv_eval_at = relids;
+			else
+				gvi->gv_eval_at = NULL;
+
+			gvi->gv_width = get_typavgwidth(exprType((Node *) gvi->gvexpr),
+											exprTypmod((Node *) gvi->gvexpr));
+
+			root->grouped_var_list = lappend(root->grouped_var_list, gvi);
+		}
+	}
+
+	list_free(tlist_exprs);
+}
+
+/*
+ * Create GroupedVarInfo for each expression usable as grouping key.
+ *
+ * In addition to the expressions of the query targetlist, group_pathkeys is
+ * also considered the source of grouping expressions. That increases the
+ * chance to get the relation output grouped.
+ */
+static void
+create_grouping_expr_grouped_var_infos(PlannerInfo *root)
+{
+	ListCell   *l1,
+			   *l2;
+	List	   *exprs = NIL;
+	List	   *sortgrouprefs = NIL;
+
+	/*
+	 * Make sure GroupedVar exists for each expression usable as grouping key.
+	 */
+	foreach(l1, root->processed_tlist)
+	{
+		TargetEntry *te = lfirst_node(TargetEntry, l1);
+		Index		sortgroupref = te->ressortgroupref;
+
+		if (sortgroupref == 0)
+			continue;
+
+		/*
+		 * Non-zero sortgroupref does not necessarily imply grouping
+		 * expression: data can also be sorted by aggregate.
+		 */
+		if (IsA(te->expr, Aggref))
+			continue;
+
+		exprs = lappend(exprs, te->expr);
+		sortgrouprefs = lappend_int(sortgrouprefs, sortgroupref);
+	}
+
+	/*
+	 * Try to derive additional grouping expressions from group_pathkeys. This
+	 * increases the chance that relation can be grouped even if its columns
+	 * are not mentioned in the grouping clause.
+	 *
+	 * It's important that we have processed the explicit grouping columns
+	 * first. If the grouping clause contains multiple expressions belonging
+	 * to the same EC, the original (i.e. not derived) one should be preferred
+	 * when we build grouping target for a relation. Otherwise we have a
+	 * problem when trying to match target entries to grouping clauses during
+	 * plan creation, see extract_grouping_cols.
+	 */
+	foreach(l1, root->group_pathkeys)
+	{
+		PathKey    *pk = lfirst_node(PathKey, l1);
+		EquivalenceClass *ec = pk->pk_eclass;
+		EquivalenceMember *em;
+		Index		sortgroupref = 0;
+
+		/* We need equality anywhere in the join tree. */
+		if (ec->ec_below_outer_join)
+			continue;
+
+		/*
+		 * TODO Reconsider this restriction. As the grouping expression is
+		 * only evaluated at the relation level (and only the result will be
+		 * propagated to the final targetlist), volatile function might be
+		 * o.k. Need to think what volatile EC exactly means.
+		 */
+		if (ec->ec_has_volatile)
+			continue;
+
+		foreach(l2, ec->ec_members)
+		{
+			ListCell   *l3;
+
+			em = lfirst_node(EquivalenceMember, l2);
+
+			/*
+			 * We search for grouping expressions now.
+			 */
+			if (IsA(em->em_expr, Aggref))
+				continue;
+
+			if (em->em_nullable_relids)
+				continue;
+
+			/*
+			 * If target list contains this expression, it should provide us
+			 * with the sortgroupref.
+			 */
+			foreach(l3, root->processed_tlist)
+			{
+				TargetEntry *te = lfirst_node(TargetEntry, l3);
+
+				if (equal(em->em_expr, te->expr))
+				{
+					/*
+					 * XXX Not sure if the same expression exist in the
+					 * targetlist multiple times and if some occurrences can
+					 * miss the ressortgroupref. Maybe we just need to
+					 * Assert() here that ressortgroupref is non-zero.
+					 */
+					if (te->ressortgroupref > 0)
+					{
+						sortgroupref = te->ressortgroupref;
+						break;
+					}
+				}
+			}
+
+			/*
+			 * If a single EC member matches, no need to check the rest of the
+			 * EC.
+			 */
+			if (sortgroupref > 0)
+				break;
+		}
+
+		if (sortgroupref == 0)
+			/* Go for the next EC. */
+			continue;
+
+		/*
+		 * The EC contains a grouping expression, so each member of that EC
+		 * should be usable as grouping key. Remember all the expressions of
+		 * the EC as well as their (supposedly common) sortgroupref for the
+		 * final processing.
+		 */
+		foreach(l2, ec->ec_members)
+		{
+			em = lfirst_node(EquivalenceMember, l2);
+			exprs = lappend(exprs, em->em_expr);
+			sortgrouprefs = lappend_int(sortgrouprefs, sortgroupref);
+		}
+	}
+
+	/*
+	 * Finally construct GroupedVarInfo for each expression.
+	 */
+	forboth(l1, exprs, l2, sortgrouprefs)
+	{
+		Expr	   *expr = (Expr *) lfirst(l1);
+		int			sortgroupref = lfirst_int(l2);
+		GroupedVarInfo *gvi = makeNode(GroupedVarInfo);
+
+		gvi->gvid = list_length(root->grouped_var_list);
+		gvi->gvexpr = (Expr *) copyObject(expr);
+		gvi->sortgroupref = sortgroupref;
+
+		/* Find out where the aggregate should be evaluated. */
+		gvi->gv_eval_at = pull_varnos((Node *) expr);
+
+		/*
+		 * If the grouping column is a plain Var, it has GroupedVarInfo (XXX
+		 * should it be so?) but the actual Var will appear in the target.
+		 * Thus set_rel_width should get better estimate from statistics. Do
+		 * not waste cycles here to get less accurate value.
+		 */
+		if (!IsA(gvi->gvexpr, Var))
+			gvi->gv_width = get_typavgwidth(exprType((Node *) gvi->gvexpr),
+											exprTypmod((Node *) gvi->gvexpr));
+
+		root->grouped_var_list = lappend(root->grouped_var_list, gvi);
+	}
+}
+
+/*
+ * Check if rel->reltarget allows the relation to be grouped and initialize
+ * the grouping target(s).
+ *
+ * target_agg is a target that we'll eventually used to aggregate the output
+ * of relation paths.
+ *
+ * If we succeed to create the grouping target, also replace rel->reltarget
+ * with a new one that has sortgrouprefs initialized --- this is necessary for
+ * create_agg_plan to match the grouping clauses against the input target
+ * expressions. (Thus the scan / join that provides the AggPath with input
+ * does not have to care whether the source relation does have grouped target
+ * or not.)
+ *
+ * The *group_exprs_extra_p list may receive additional grouping expressions
+ * that the query does not have. These can make the aggregation of base
+ * relation / join less efficient, but it may still be better than not trying
+ * at all.
+ *
+ * TODO Make sure cost / width of both "result" and "plain" are correct.
+ */
+void
+initialize_grouped_target(PlannerInfo *root, RelOptInfo *rel,
+						  PathTarget *target_agg,
+						  List **group_exprs_extra_p)
+{
+	PathTarget *target_plain;
+	ListCell   *lc1;
+	List	   *vars_unresolved = NIL;
+
+	/* The target to replace rel->reltarget. */
+	target_plain = create_empty_pathtarget();
+
+	foreach(lc1, rel->reltarget->exprs)
+	{
+		Var		   *tvar;
+		GroupedVar *gvar;
+
+		/*
+		 * Given that PlaceHolderVar currently prevents us from doing
+		 * aggregation push-down, the source target cannot contain anything
+		 * more complex than a Var. (As for generic grouping expressions,
+		 * add_grouped_vars_to_target will retrieve them from the query
+		 * targetlist and add them to target_agg outside this function.)
+		 */
+		tvar = lfirst_node(Var, lc1);
+
+		gvar = get_grouping_expression(root, (Expr *) tvar);
+		if (gvar != NULL)
+		{
+			/*
+			 * It's o.k. to use the target expression for grouping.
+			 *
+			 * The actual Var is added to the target. If we used the
+			 * containing GroupedVar, references from various clauses (e.g.
+			 * join quals) wouldn't work.
+			 */
+			add_column_to_pathtarget(target_agg, (Expr *) gvar->gvexpr,
+									 gvar->sortgroupref);
+
+			/*
+			 * As for the plain target, add the original expression but set
+			 * sortgroupref in addition.
+			 */
+			add_column_to_pathtarget(target_plain, gvar->gvexpr,
+									 gvar->sortgroupref);
+
+			/* Process the next expression. */
+			continue;
+		}
+
+		/*
+		 * Further investigation involves dependency check, for which we need
+		 * to have all the plain-var grouping expressions gathered. So far
+		 * only store the var in a list.
+		 */
+		vars_unresolved = lappend(vars_unresolved, tvar);
+	}
+
+	/*
+	 * Check for other possible reasons for the var to be in the plain target.
+	 */
+	foreach(lc1, vars_unresolved)
+	{
+		Var		   *var;
+		RangeTblEntry *rte;
+		List	   *deps = NIL;
+		Relids		relids_subtract;
+		int			ndx;
+		RelOptInfo *baserel;
+
+		var = lfirst_node(Var, lc1);
+		rte = root->simple_rte_array[var->varno];
+
+		/*
+		 * Dependent var is almost the same as one that has sortgroupref.
+		 */
+		if (check_functional_grouping(rte->relid, var->varno,
+									  var->varlevelsup,
+									  target_agg->exprs, &deps))
+		{
+
+			Index		sortgroupref = 0;
+
+			add_column_to_pathtarget(target_agg, (Expr *) var, sortgroupref);
+
+			/*
+			 * The var shouldn't be actually used as a grouping key (instead,
+			 * the one this depends on will be), so sortgroupref should not be
+			 * important. But once we have it ...
+			 */
+			add_column_to_pathtarget(target_plain, (Expr *) var,
+									 sortgroupref);
+
+			/*
+			 * The var may or may not be present in generic grouping
+			 * expression(s) or aggregate arguments, but we already have it in
+			 * the targets, so don't care.
+			 */
+			continue;
+		}
+
+		/*
+		 * Isn't the expression needed by joins above the current rel?
+		 *
+		 * The relids we're not interested in do include 0, which is the
+		 * top-level targetlist. The only reason for relids to contain 0
+		 * should be that arg_var is referenced either by aggregate or by
+		 * grouping expression, but right now we're interested in the *other*
+		 * reasons. (As soon as GroupedVars are installed, the top level
+		 * aggregates / grouping expressions no longer need direct reference
+		 * to arg_var anyway.)
+		 */
+		relids_subtract = bms_copy(rel->relids);
+		bms_add_member(relids_subtract, 0);
+
+		baserel = find_base_rel(root, var->varno);
+		ndx = var->varattno - baserel->min_attr;
+		if (bms_nonempty_difference(baserel->attr_needed[ndx],
+									relids_subtract))
+		{
+			/*
+			 * The variable is needed by upper join. This includes one that is
+			 * referenced by a generic grouping expression but couldn't be
+			 * recognized as grouping expression on its own at the top of the
+			 * loop.
+			 *
+			 * The only way to bring this var to the aggregation output is to
+			 * add it to the grouping expressions too.
+			 *
+			 * Since root->parse->groupClause is not supposed to contain this
+			 * expression, we need construct special SortGroupClause. Its
+			 * tleSortGroupRef needs to be unique within target_agg, so
+			 * postpone creation of the SortGroupRefs until we're done with
+			 * the iteration of rel->reltarget->exprs.
+			 */
+			*group_exprs_extra_p = lappend(*group_exprs_extra_p, var);
+		}
+		else
+		{
+			/*
+			 * As long as the query is semantically correct, arriving here
+			 * means that the var is referenced either by aggregate argument
+			 * or by generic grouping expression. The aggregation target
+			 * should not contain it, as it only provides input for the final
+			 * aggregation.
+			 */
+		}
+
+		/*
+		 * The var is not suitable for grouping, but the plain target ought to
+		 * stay complete.
+		 */
+		add_column_to_pathtarget(target_plain, (Expr *) var, 0);
+	}
+
+	/*
+	 * Apply the adjusted input target as the replacement is complete now.
+	 */
+	/* TODO Free the old one. */
+	rel->reltarget = target_plain;
+}
+
 
 /*****************************************************************************
  *
diff --git a/src/backend/optimizer/plan/planagg.c b/src/backend/optimizer/plan/planagg.c
index 889e8af..73bccee 100644
--- a/src/backend/optimizer/plan/planagg.c
+++ b/src/backend/optimizer/plan/planagg.c
@@ -223,7 +223,7 @@ preprocess_minmax_aggregates(PlannerInfo *root, List *tlist)
 			 create_minmaxagg_path(root, grouped_rel,
 								   create_pathtarget(root, tlist),
 								   aggs_list,
-								   (List *) parse->havingQual));
+								   (List *) parse->havingQual), false);
 }
 
 /*
diff --git a/src/backend/optimizer/plan/planmain.c b/src/backend/optimizer/plan/planmain.c
index f4e0a6e..2bf4c8b 100644
--- a/src/backend/optimizer/plan/planmain.c
+++ b/src/backend/optimizer/plan/planmain.c
@@ -83,7 +83,7 @@ query_planner(PlannerInfo *root, List *tlist,
 		add_path(final_rel, (Path *)
 				 create_result_path(root, final_rel,
 									final_rel->reltarget,
-									(List *) parse->jointree->quals));
+									(List *) parse->jointree->quals), false);
 
 		/* Select cheapest path (pretty easy in this case...) */
 		set_cheapest(final_rel);
@@ -114,6 +114,7 @@ query_planner(PlannerInfo *root, List *tlist,
 	root->full_join_clauses = NIL;
 	root->join_info_list = NIL;
 	root->placeholder_list = NIL;
+	root->grouped_var_list = NIL;
 	root->fkey_list = NIL;
 	root->initial_rels = NIL;
 
@@ -177,6 +178,14 @@ query_planner(PlannerInfo *root, List *tlist,
 	(*qp_callback) (root, qp_extra);
 
 	/*
+	 * If the query result can be grouped, check if any grouping can be
+	 * performed below the top-level join. If so, Initialize GroupedPathInfo
+	 * of base relations capable to do the grouping and setup
+	 * root->grouped_var_list.
+	 */
+	add_grouping_info_to_base_rels(root);
+
+	/*
 	 * Examine any "placeholder" expressions generated during subquery pullup.
 	 * Make sure that the Vars they need are marked as needed at the relevant
 	 * join level.  This must be done before join removal because it might
